<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));

if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');

$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();

$session_id=isset($_POST['F_ORDER_NUMBER'])?$_POST['F_ORDER_NUMBER']:"";

if($session_id=="")
  exit;
$module_id=0;
$tarr=explode("-",$session_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;
  
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."methods".DS."plationline.php");

$params=$PMBHelper->getWorkingModParams($module_id);

$my_class = new platiOnlineHelper();

$my_class->LoginID = $params['plationline_user'];
$my_class->KeyEnc = $params['plationline_enc_key'];
$my_class->KeyMod = $params['plationline_enc_mode'];

$vF_Message_Relay = $_POST["F_MESSAGE_RELAY"];
$vF_Crypt_Message_Relay = $_POST["F_CRYPT_MESSAGE_RELAY"];
$vX_RESPONSE_CODE = $_POST["X_RESPONSE_CODE"];
$vX_RESPONSE_REASON_TEXT = $_POST["X_RESPONSE_REASON_TEXT"];
$vF_ORDER_NUMBER = $_POST["F_ORDER_NUMBER"];
$vF_Amount = $_POST["F_AMOUNT"];
$vF_Currency = $_POST["F_CURRENCY"];
$vX_TRAN_ID = $_POST["X_TRAN_ID"];

$vMy_F_Message_Relay = strtoupper($my_class->VerifyFRM(strval($vF_Message_Relay)));

// make sure the response it is from PlatiOnline.ro servers
if($vF_Crypt_Message_Relay != $vMy_F_Message_Relay)
	die("ERROR!!!<hr>hacking attempt.[Relay Message]");

$vA = explode("^", $vF_Message_Relay);
$order_paid=0;
// if the curency do not match with the message currency decline the transaction
$vCurrencyMessage = $vA[4];
if($vCurrencyMessage!=$vF_Currency)
	$order_paid=0;

// if the amount do not match with the message amount decline the transaction
$vAmountMessage = $vA[3];
if($vAmountMessage != $vF_Amount)	
	$order_paid=0;
// if the response code do not match with the message response code decline the transaction

$vX_Response_Code_Message= $vA[5];

if($vX_RESPONSE_CODE != $vX_Response_Code_Message)
	$order_paid=0;

switch ($vX_RESPONSE_CODE) {
case "2":  // tranzactia a fost autorizata
	$order_paid=1;
	break;
case "8":  // tranzactia a fost refuzata
	$order_paid=0;
	break;
case "10": // eroare in procesul de autorizare
	$order_paid=0;
	break;
case "13": // tranzactia necesita verificari suplimentare
	$order_paid=0;
	break;
default:
	$order_paid=0;
}



$method_name='PlatiOnline';

$message="";
$message2="";
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);
if($order_paid == 1)
{
  $message='<h1><font color="green"><strong>'.JText::_( 'PMB_MODULE_ORDER_SUCCESS' ).'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_SUCCESS' )).'\');';
  //send mail
  if($params['mail_success']!=0)
  {
    $pmbf->sendConfirmationMail('success',$params,$details,$method_name);
  }
  $pmbf->setOrderSuccess($params,$details,$method_name);
}
else
{
  $message='<h1><font color="red"><strong>'.JText::_( 'PMB_MODULE_ORDER_CANCELED' ).'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_CANCELED' )).'\');';
  //send mail
  if($params['mail_cancelled']!=0)
  {
    $pmbf->sendConfirmationMail('cancelled',$params,$details,$method_name);
  }
  $pmbf->setOrderCancelled($params,$details,$method_name);
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title></title>
  </head>
  <body>
    <?php echo $message;?>
    <a href="http://<?php echo $_SERVER['HTTP_HOST']?>">Click Here</a> to renturn to our website.
    <script type="text/javascript">
    <?php echo $message2;?>
    window.location='http://<?php echo $_SERVER['HTTP_HOST']?>';
    </script>
  </body>
</html>